#include <cstdio>
#include <algorithm>
#include <vector>
#include <cmath>

using namespace std;

int main() {
    int n, k, v;
    long long sum = 0, formula, rez;
    vector <int> A;
    scanf("%d%d", &n, &k);
    for(int i = 0; i < n; i++) {
        scanf("%d", &v);
        A.push_back(v);
    }


if(k == 0) {
    for(int i = 0;i < n; i++) {
        sum = sum + A[i];
    }

}

else {
    for(int q = 0; q < n; q++){
        for(int i = 0; i < n; i++) {
            for(int j = q; j <= i; j++) {
                sum = sum + A[j];
            }
        }
    }
}

formula = (pow(10,9) + 7);
rez = sum % formula;
printf("%lld", rez);

return 0;
}